## libequihash 1.0.6

=== Makefile ===
CXXFLAGS=-Wall -g -O3 -std=c++17 -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fasynchronous-unwind-tables -fpic -Werror=format-security -Wl,-z,defs -Wl,-z,relro -ftrapv -Wl,-z,noexecstack
LIBS=-lsodium
PREFIX?=/usr/local
SOEXT?=so
EXTRA_CXXFLAGS=-fstack-clash-protection
#EXTRA_CXXFLAGS+=-march=native 
INSTALL?=install

SYS=$(shell gcc -dumpmachine)
ifneq (, $(findstring x86_64, $(SYS)))
    EXTRA_CXXFLAGS+=-fcf-protection=full
endif

all: libequihash.so libequihash.a

android: EXTRA_SOURCES=jni.cc
android: CXXFLAGS+=-I$(SODIUM) -I$(SODIUM)/sodium -L.
android: libequihash.so
android: EXTRA_CXXFLAGS=

equihash.o: equihash.cc equihash.h equihash.hpp Makefile
	$(CXX) -c $(CXXFLAGS) $(EXTRA_CXXFLAGS) -o equihash.o equihash.cc

libequihash.so: equihash.o Makefile $(EXTRA_SOURCES)
	$(CXX) -shared $(CXXFLAGS) $(EXTRA_CXXFLAGS) -Wl,-soname,libequihash.so.0 -o libequihash.so equihash.o $(EXTRA_SOURCES) $(LIBS)

libequihash.a: equihash.o
	ar rcs $@ $^

bench: equihash.cc equihash.hpp equihash-test.cc Makefile libequihash.so
	$(CXX) -Wall -march=native -O3 -std=c++17 equihash-test.cc $(LIBS) -L. -lequihash -o bench

libequihash.pc:
	echo "prefix=$(PREFIX)" >libequihash.pc
	cat libequihash.pc.skel >>libequihash.pc

install: $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT) $(DESTDIR)$(PREFIX)/lib/libequihash.a $(DESTDIR)$(PREFIX)/include/equihash.h $(DESTDIR)$(PREFIX)/share/pkgconfig/libequihash.pc

$(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT): libequihash.$(SOEXT)
	$(INSTALL) -D $< $@


$(DESTDIR)$(PREFIX)/lib/libequihash.a: libequihash.a
	$(INSTALL) -D -m 0644 $< $@

$(DESTDIR)$(PREFIX)/include/equihash.h: equihash.h
	$(INSTALL) -D -m 0644 $< $@

$(DESTDIR)$(PREFIX)/share/pkgconfig/libequihash.pc: libequihash.pc
	$(INSTALL) -D -m 0644 $< $@

clean:
	rm -f bench libequihash.so libequihash.pc libequihash.a equihash.o

=== debian/changelog ===
libequihash (1.0.6-2) unstable; urgency=low

  * No longer builds the python3-equihash binary (all) package.  This binary
    package is to be replaced by python3-pyequihash (>= 0.2-1) as built from
    the new pyequihash source package.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Sat, 28 Jan 2023 12:51:16 +0100

libequihash (1.0.6-1) unstable; urgency=low

  * New upstream. Missed 1.0.5. Upstream changes:
    [ 2023-01-09  stf <7o5rfu92t@ctrlc.hu> ]
    - Makefile: [fix] also disable -march=native to enable
      crosscompilation
    [ 2023-01-08  stf <7o5rfu92t@ctrlc.hu> ]
    - Makefile: [mod] excluded bench target from all in makefile, since
      it is not very portable
    - python/setup.py: [mod] bumped v of py bindings to 0.2

  [ lintian-brush ]
  * d/upstream/metadata: Set upstream metadata fields: Bug-Database,
    Bug-Submit, Repository-Browse.
  * d/control: Update standards version to 4.6.2, no changes needed.
  * d/rules: Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Mon, 09 Jan 2023 13:45:24 +0100

libequihash (1.0.4-2) unstable; urgency=low

  * Reupload in order to force a rebuild attempt on the buildd's.  I fail
    to reproduce the error in building on my local amd64 sbuild instance; the
    error ("FTBFS on !x86") on the buildd site might be transient.  This
    should finally: Closes: #1024239.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Sun, 08 Jan 2023 14:09:49 +0100

libequihash (1.0.4-1) unstable; urgency=low

  * New upstream.
    - Set gcc flag -fstack-clash-protection on amd64 only.  Tnx Stefan.
      Closes: #1024239.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Fri, 30 Dec 2022 13:32:21 +0100

libequihash (1.0.3-1) unstable; urgency=low

  * New upstream.
    - Do net set gcc flags "-march=native -fstack-clash-protection" on i386.
      This (party) fixes #1024239 "baseline violation on i386 and FTBFS on
      !x86".  tnx Adrian Bunk.
    - The build failure reported in "binary-any FTBFS" was not reproduced
      with this upstream release.  Tnx again Adrian Bunk. (Closes: #1024238).
  * d/rules: disable python tests: these currently need a system installed
    libequihash.so.0.
  * d/copyright: don't use ', ' but ' ' as filename separator, tnx lintian.
  * d/python3-equihash.docs: install upstream python README.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Fri, 30 Dec 2022 11:35:14 +0100

libequihash (1.0.2-3) unstable; urgency=low

  * Reupload as source only.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Sun, 13 Nov 2022 09:42:25 +0100

libequihash (1.0.2-2) unstable; urgency=low

  * d/copyright: fix up, thanks Thorsten Alteholz.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Tue, 08 Nov 2022 07:58:18 +0100

libequihash (1.0.2-1) unstable; urgency=low

  * New upstream: no longer ships debian/.  Thanks Stefan.
  * First upload to Debian archive (Closes: #1021433).
  * d/control: change Maintainer from Stefan Marsiske to myself, add Uploaders:
    jdx5yg90@ctrlc.hu, as agreed upon with upstream.
  * d/control: enhance descriptions reusing blurb from ITP.
  * d/control: Build-Depends: add missing libsodium-dev.
  * d/rules,control,libequihash.install: rename package libequihash to
    libequihash0, in order to match soname.
  * d/control: add missing ${shlibs:Depends} to libequihash0 Depends.
  * d/README.Debian: remove: is copy of information in package description.
  * d/libequihash0.docs: added: install upstream README.md.
  * d/copyright: cleanup; add myself on debian/*.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Fri, 28 Oct 2022 15:30:30 +0200

libequihash (1.0-1) unstable; urgency=low

  * Initial release.

 -- Stefan Marsiske <sphinx@ctrlc.hu>  Thu, 09 Jun 2022 21:09:55 +0200

=== debian/control ===
Source: libequihash
Section: utils
Priority: optional
Maintainer: Joost van Baal-Ilić <joostvb@debian.org>
Uploaders: Stefan Marsiske <jdx5yg90@ctrlc.hu>
Build-Depends: debhelper-compat (= 13), dh-exec (>=0.3), libsodium-dev
Standards-Version: 4.6.2
Homepage: https://github.com/stef/equihash/
Rules-Requires-Root: no

Package: libequihash-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libequihash0 (= ${binary:Version}), ${misc:Depends}
Description: memory-hard Proof-of-Work with fast verification - C development files
 Equihash implements the algorith as described in "Equihash: Asymmetric
 Proof-of-Work Based on the Generalized Birthday Problem" by Alex Biryukov and
 Dmitry Khovratovich, 2016, DOI:10.14722/ndss.2016.23108.  This code, by Stefan
 Marsiske, is a fork of an earlier implementation by Khovratovich at
 https://github.com/khovratovich/equihash/ ; it provides a library, a C API and
 Python bindings.  The cryptographic password storage SPHINX (pwdsphinx and
 libsphinx) depend upon equihash.
 .
 This package offers the C library development files.

Package: libequihash0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends},
   build-essential,
   libsodium23 (>= 1.0.18)
Description: memory-hard Proof-of-Work with fast verification - C library
 Equihash implements the algorith as described in "Equihash: Asymmetric
 Proof-of-Work Based on the Generalized Birthday Problem" by Alex Biryukov and
 Dmitry Khovratovich, 2016, DOI:10.14722/ndss.2016.23108.  This code, by Stefan
 Marsiske, is a fork of an earlier implementation by Khovratovich at
 https://github.com/khovratovich/equihash/ . The cryptographic password storage
 SPHINX (pwdsphinx and libsphinx) depend upon equihash.
 .
 This library contains an optimized C++ implementation.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export PREFIX=/usr

%:
	dh $@ -p libequihash-dev -p libequihash0

## libequihash 1.0.9

=== Makefile ===
CFLAGS?=-Wall -g -O3 -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fasynchronous-unwind-tables -fpic -Werror=format-security -Wl,-z,defs -Wl,-z,relro -ftrapv -Wl,-z,noexecstack
CXXFLAGS?=-Wall -g -O3 -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fasynchronous-unwind-tables -fpic -Werror=format-security -Wl,-z,defs -Wl,-z,relro -ftrapv -Wl,-z,noexecstack
CXXFLAGS+=-std=c++17
LIBS=-lsodium
PREFIX?=/usr/local
SOEXT?=so
EXTRA_CXXFLAGS=-fstack-clash-protection
#EXTRA_CXXFLAGS+=-march=native 
INSTALL?=install

SYS=$(shell gcc -dumpmachine)
ifneq (, $(findstring x86_64, $(SYS)))
    EXTRA_CXXFLAGS+=-fcf-protection=full
endif

all: libequihash.so libequihash.a equihash

android: EXTRA_SOURCES=jni.cc
android: CXXFLAGS+=-I$(SODIUM) -I$(SODIUM)/sodium -L.
android: libequihash.so
android: EXTRA_CXXFLAGS=

equihash.o: equihash.cc equihash.h equihash.hpp Makefile
	$(CXX) -c $(CXXFLAGS) $(EXTRA_CXXFLAGS) -o equihash.o equihash.cc

libequihash.so: equihash.o Makefile $(EXTRA_SOURCES)
	$(CXX) -shared $(CXXFLAGS) $(EXTRA_CXXFLAGS) -Wl,-soname,libequihash.so.0 -o libequihash.so equihash.o $(EXTRA_SOURCES) $(LIBS)

libequihash.a: equihash.o
	ar rcs $@ $^

bench.o: bench.cc
	$(CXX) -c $(CXXFLAGS) -o bench.o bench.cc

equihash: main.c bench.o libequihash.a
	$(CC) -g $(CFLAGS) main.c $(LIBS) bench.o libequihash.a $(LIBS) -lstdc++ -o equihash

libequihash.pc:
	echo "prefix=$(PREFIX)" >libequihash.pc
	cat libequihash.pc.skel >>libequihash.pc

install: $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT) $(DESTDIR)$(PREFIX)/lib/libequihash.a $(DESTDIR)$(PREFIX)/include/equihash.h $(DESTDIR)$(PREFIX)/share/pkgconfig/libequihash.pc $(DESTDIR)$(PREFIX)/bin/equihash $(DESTDIR)$(PREFIX)/bin/ehwait $(DESTDIR)$(PREFIX)/bin/ehpuzzle

$(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT): libequihash.$(SOEXT)
	$(INSTALL) -D $< $@

$(DESTDIR)$(PREFIX)/lib/libequihash.a: libequihash.a
	$(INSTALL) -D -m 0644 $< $@

$(DESTDIR)$(PREFIX)/include/equihash.h: equihash.h
	$(INSTALL) -D -m 0644 $< $@

$(DESTDIR)$(PREFIX)/share/pkgconfig/libequihash.pc: libequihash.pc
	$(INSTALL) -D -m 0644 $< $@

$(DESTDIR)$(PREFIX)/bin/equihash: equihash
	$(INSTALL) -D -m 0755 $< $@

$(DESTDIR)$(PREFIX)/bin/ehwait: ehwait
	$(INSTALL) -D -m 0755 $< $@

$(DESTDIR)$(PREFIX)/bin/ehpuzzle: ehpuzzle
	$(INSTALL) -D -m 0755 $< $@

clean:
	rm -f libequihash.so libequihash.pc libequihash.a equihash.o bench.o equihash

=== debian/changelog ===
libequihash (1.0.9-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:44:44 +0200

libequihash (1.0.9-1) unstable; urgency=low

  * New upstream.  Upstream changes:
    - Various improvements in Makefile and ehpuzzle.

  [ Stefan Marsiske ]
  * set correct d/watch
  * fixed a bunch of lintian issues

  [ Joost van Baal-Ilić ]
  * d/changelog: sync email address as used in d/control and here.
  * d/changelog: drop confusing remark about debian/ vs upstream.
  * d/control: add Vcs-* fields.

 -- Stefan Marsiske <jdx5yg90@ctrlc.hu>  Sat, 29 Jul 2023 01:48:24 +0100

libequihash (1.0.8-1) unstable; urgency=low

  * New upstream. Upstream changes:
    - New CLI mode size, notification interface & simple wrapper for it, and a
      new puzzle wrapper.

 -- Stefan Marsiske <jdx5yg90@ctrlc.hu>  Tue, 31 Jan 2023 17:35:24 +0100

libequihash (1.0.7-1) unstable; urgency=low

  * New upstream. Upstream changes:
    - Makefile: [enh] new portable CLI frontend

 -- Stefan Marsiske <jdx5yg90@ctrlc.hu>  Tue, 31 Jan 2023 17:35:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,15 @@
 Source: libequihash
 Section: utils
 Priority: optional
-Maintainer: Joost van Baal-Ilić <joostvb@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Joost van Baal-Ilić <joostvb@debian.org>
 Uploaders: Stefan Marsiske <jdx5yg90@ctrlc.hu>
 Build-Depends: debhelper-compat (= 13), dh-exec (>=0.3), libsodium-dev
 Standards-Version: 4.6.2
+Rules-Requires-Root: no
 Homepage: https://github.com/stef/equihash/
-Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/libequihash
+Vcs-Git: https://salsa.debian.org/debian/libequihash.git
 
 Package: libequihash-dev
 Section: libdevel
@@ -32,6 +35,7 @@
 Pre-Depends: ${misc:Pre-Depends},
    build-essential,
    libsodium23 (>= 1.0.18)
+Suggests: libequihash-bin
 Description: memory-hard Proof-of-Work with fast verification - C library
  Equihash implements the algorith as described in "Equihash: Asymmetric
  Proof-of-Work Based on the Generalized Birthday Problem" by Alex Biryukov and
@@ -41,3 +45,17 @@
  SPHINX (pwdsphinx and libsphinx) depend upon equihash.
  .
  This library contains an optimized C++ implementation.
+
+Package: libequihash-bin
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Description: memory-hard Proof-of-Work with fast verification - CLI frontend executable
+ Equihash implements the algorith as described in "Equihash: Asymmetric
+ Proof-of-Work Based on the Generalized Birthday Problem" by Alex Biryukov and
+ Dmitry Khovratovich, 2016, DOI:10.14722/ndss.2016.23108.  This code, by Stefan
+ Marsiske, is a fork of an earlier implementation by Khovratovich at
+ https://github.com/khovratovich/equihash/ .
+ .
+ This package contains a simple CLI executable to benchmark, solve and verify
+ Equihash Challenges.

## libequihash 1.0.10

=== Makefile ===
--- 
+++ 
@@ -39,10 +39,13 @@
 	echo "prefix=$(PREFIX)" >libequihash.pc
 	cat libequihash.pc.skel >>libequihash.pc
 
-install: $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT) $(DESTDIR)$(PREFIX)/lib/libequihash.a $(DESTDIR)$(PREFIX)/include/equihash.h $(DESTDIR)$(PREFIX)/share/pkgconfig/libequihash.pc $(DESTDIR)$(PREFIX)/bin/equihash $(DESTDIR)$(PREFIX)/bin/ehwait $(DESTDIR)$(PREFIX)/bin/ehpuzzle
+install: $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT) $(DESTDIR)$(PREFIX)/lib/libequihash.a $(DESTDIR)$(PREFIX)/include/equihash.h $(DESTDIR)$(PREFIX)/share/pkgconfig/libequihash.pc $(DESTDIR)$(PREFIX)/bin/equihash $(DESTDIR)$(PREFIX)/bin/ehwait $(DESTDIR)$(PREFIX)/bin/ehpuzzle $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT).0
 
 $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT): libequihash.$(SOEXT)
 	$(INSTALL) -D $< $@
+
+$(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT).0: $(DESTDIR)$(PREFIX)/lib/libequihash.$(SOEXT)
+	ln -s $< $@
 
 $(DESTDIR)$(PREFIX)/lib/libequihash.a: libequihash.a
 	$(INSTALL) -D -m 0644 $< $@

=== debian/changelog ===
libequihash (1.0.10-2) unstable; urgency=low

  * Fix bug: Previous build 1.0.10-1 contained
    dangling symlink lrwxrwxrwx root/root 0 2024-12-08 14:50
    ./usr/lib/x86_64-linux-gnu/libequihash.so.0 ->
    /build/reproducible-path/libequihash-1.0.10/debian/tmp/usr/lib/libequihash.so
    .
    - d/libequihash0.install : change usr/lib/libequihash.so.0 in
      usr/lib/libequihash.so
    - d/not-installed : change usr/lib/libequihash.so in
      usr/lib/libequihash.so.0

 -- Joost van Baal-Ilić <joostvb@debian.org>  Sun, 15 Dec 2024 15:07:54 +0100

libequihash (1.0.10-1) unstable; urgency=low

  * New upstream, released Aug 25, 2024.  Upstream changes:
    - [mod] add rule to makefile to install libequihash.so.0 as a softlink
    - [mod] compile with msvc
    - [fix] implicit copy constructor vs explicit copy assignment operator

  * d/libequihash0.install: change u/l/libequihash.so to libequihash.so.0.
  * d/not-installed: added: list libequihash.so.

 -- Joost van Baal-Ilić <joostvb@debian.org>  Sun, 08 Dec 2024 15:50:48 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libequihash
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Joost van Baal-Ilić <joostvb@debian.org>
+Maintainer: Joost van Baal-Ilić <joostvb@debian.org>
 Uploaders: Stefan Marsiske <jdx5yg90@ctrlc.hu>
 Build-Depends: debhelper-compat (= 13), dh-exec (>=0.3), libsodium-dev
 Standards-Version: 4.6.2

=== debian/rules ===
--- 
+++ 
@@ -8,4 +8,4 @@
 export PREFIX=/usr
 
 %:
-	dh $@ -p libequihash-dev -p libequihash0
+	dh $@ -p libequihash-dev -p libequihash0 -p libequihash-bin

=== debian/watch ===
version=4
opts="\
dversionmangle=s/\+dfsg.*$//,\
filenamemangle=s/.+\/[vV]?(\d\S+)\.tar\.gz/libequihash-$1\.tar\.gz/,\
repack,repacksuffix=+dfsg,\
" \
https://github.com/stef/equihash/tags .*/[vV]?(\d[^\s+]+)\.tar\.gz
